
.386p

        NAME    A_FLIC

        .model small, c

DGROUP  GROUP   _DATA


_DATA   SEGMENT DWORD PUBLIC USE32 'DATA'

EXTERN  _FLIC_videoBufSeg   : dword
EXTERN  _FLIC_videoBufSizeX : dword
EXTERN  _FLIC_videoBufOff   : dword
EXTERN  _FLIC_width         : dword
EXTERN  _FLIC_length        : dword



_DATA   ENDS

PUBLIC  _FLIC_BRUN
PUBLIC  _FLIC_LC
PUBLIC  _FLIC_SS2


_TEXT   SEGMENT BYTE PUBLIC USE32 'CODE'
                ASSUME  CS:_TEXT ,DS:DGROUP,SS:DGROUP

_FLIC_BRUN           PROC USES esi edi eax ebx ecx edx,
        flicBuf    : dword

        LOCAL   len : dword, w : dword, dstFormatX : dword

        push    es
        mov     eax,_FLIC_length
        mov     len,eax
        mov     eax,_FLIC_width
        mov     w,eax
        mov     esi,flicBuf
        mov     eax,_FLIC_videoBufSeg
        mov     es,ax
        mov     edi,_FLIC_videoBufOff
        mov     eax,_FLIC_videoBufSizeX
        mov     dstFormatX,eax
BR_width:
        push    edi
        mov     ebx,len
        inc     esi
        add     ebx,edi
BR_length:
        mov     eax,[esi]
        movsx   ecx,al
        or      ecx,ecx
        jg      BR_memset

BR_memcpy:
        neg     ecx
        mov     eax,ecx
        inc     esi
        shr     ecx,2
        repne   movsd
        and     eax,3
        je      BR_mc2
        dec     eax
        je      BR_mc1
        movsw
        dec     eax
        je      BR_mc2
BR_mc1:
        movsb
BR_mc2:
        jmp     BR_loopEnd

BR_memset:
        mov     al,ah
        add     esi,2
        shl     eax,16
        mov     edx,eax
        shr     edx,16
        or      eax,edx
        mov     edx,ecx
        shr     ecx,2
        repne   stosd
        and     edx,3
        je      BR_ms2
        dec     edx
        je      BR_ms1
        stosw
        dec     edx
        je      BR_ms2
BR_ms1:
        stosb
BR_ms2:

BR_loopEnd:
        cmp     edi,ebx
        jb      BR_length
        pop     edi
        add     edi,dstFormatX
        dec     w
        jne     BR_width
        pop     es
        ret

_FLIC_BRUN      ENDP

_FLIC_LC        PROC USES esi edi eax ebx ecx edx,
                flicBuf : dword

        LOCAL   w : dword, dstFormatX : dword

        push    es
;        inc     count
;        cmp     count,21
;        jne     LC_1
;        nop
;LC_1:
        mov     edx,_FLIC_videoBufSizeX
        mov     dstFormatX,edx
        mov     eax,_FLIC_videoBufSeg
        mov     es,ax
        mov     edi,_FLIC_videoBufOff
        mov     esi,flicBuf
        mov     ebx,[esi]
        movzx   eax,bx
        add     esi,4
        mul     edx
        add     edi,eax
        shr     ebx,16
        je      LC_end
        mov     w,ebx
        mov     eax,[esi]

LC_width:
        push    edi
        movzx   ebx,al
        inc     esi
        or      ebx,ebx
        je      LC_nextLoop
        shr     eax,8

LC_length:
        movzx   edx,al
        add     edi,edx
        movsx   ecx,ah
        or      ecx,ecx
        jl      LC_memset

LC_memcpy:
        add     esi,2
        mov     eax,ecx
        shr     ecx,2
        repne   movsd
        and     eax,3
        je      LC_mc2
        dec     eax
        je      LC_mc1
        movsw
        dec     eax
        je      LC_mc2
LC_mc1:
        movsb
LC_mc2:
        jmp     LC_loopEnd

LC_memset:
        neg     ecx
        add     esi,3
        shr     eax,8
        mov     al,ah
        shl     eax,16
        mov     edx,eax
        shr     edx,16
        or      eax,edx
        mov     edx,ecx
        shr     ecx,2
        repne   stosd
        and     edx,3
        je      LC_ms2
        dec     edx
        je      LC_ms1
        stosw
        dec     edx
        je      LC_ms2
LC_ms1:
        stosb
LC_ms2:

LC_loopEnd:
        dec     ebx
LC_nextLoop:
        mov     eax,[esi]
        jne     LC_length
        pop     edi
        add     edi,dstFormatX
;        mov     edx,w
;        cmp     edx,88h
;        jne     LC_l
;        nop
;LC_l:
        dec     w
        jne     LC_width
LC_end:
        pop     es
        ret

_FLIC_LC        ENDP

_FLIC_SS2       PROC USES esi edi eax ebx ecx edx,
                flicBuf : dword

        LOCAL   dstFormatX : dword, lines : dword

        push    es
        mov     ecx,_FLIC_videoBufSizeX
        mov     dstFormatX,ecx
        mov     eax,_FLIC_videoBufSeg
        mov     es,ax
        mov     edi,_FLIC_videoBufOff
        mov     esi,flicBuf
        mov     eax,[esi]
        cwde
        mov     lines,eax
        add     esi,2

SS2_line:

;SS2_lineLoop:
        mov     eax,[esi]
        mov     ebx,eax
        shr     ebx,16
        cwde
        bt      eax,15
        jnc     SS2_col1
        neg     eax
        mul     ecx
        add     edi,eax

        mov     eax,ebx
        add     esi,4
        jmp     SS2_col2

;        bt      eax,15
;        jnc     SS2_col2
;        neg     eax
;        mul     ecx
;        add     edi,eax
;        jmp     SS2_lineLoop

SS2_col1:
        add     esi,2
;        or      eax,eax
;        je      SS2_nextLine
        mov     ebx,eax
;        jmp     SS2_colLoop

SS2_col2:
;        or      ebx,ebx
;        je      SS2_nextLine
        push    edi
SS2_colLoop:
        mov     eax,[esi]
        movzx   ecx,al
        add     edi,ecx
        movsx   ecx,ah
        or      ecx,ecx
        jl      SS2_memset

SS2_memcpy:
        add     esi,2
        mov     eax,ecx
        shr     ecx,1
        repne   movsd
        and     eax,1
        je      SS2_loopEnd
        movsw
SS2_skipMw:
        jmp     SS2_loopEnd

SS2_memset:
        neg     ecx
        add     esi,4
        shr     eax,8
        movzx   edx,ah
        mov     al,ah
        repne   stosw
;        mov     dh,ah
;        shl     eax,16
 ;       or      eax,edx
;        mov     edx,ecx
;        shr     ecx,1
;        repne   stosd
;        and     edx,1
;        je      SS2_loopEnd
;        stosw
SS2_loopEnd:
        dec     ebx
        jne     SS2_colLoop
SS2_nextLine:
        pop     edi
        mov     ecx,dstFormatX
        add     edi,ecx
        dec     lines
        jne     SS2_line
        pop     es
        ret
_FLIC_SS2        ENDP

_TEXT   ENDS

                END
