
#ifndef __VSB_H__
  #define __VSB_H__

  #ifdef __cplusplus
  extern "C" {
  #endif


  extern char *VSB_buf;
  extern char *VSB_sbuf;
  extern int VSB_virtualX;
  extern int VSB_virtualY;
  extern long VSB_virtual;

  extern int VSB_curX;
  extern int VSB_curY;
  extern int VSB_curXNext;
  extern int VSB_curYNext;

  void VSB_done (void);
  int VSB_init (void);

  void VSB_putPixel (int x, int y, int color);

  int VSB_getPixel (int x, int y);


  void VSB_putWin (char *raw, int x, int y, int sizeX, int sizeY, int formatX);

  void VSB_putSpr (char *raw, int x, int y, int sizeX, int sizeY, int formatX);

  void VSB_getWin (char *raw, int x, int y, int sizeX, int sizeY, int formatX);

  void VSB_sput (char *raw, int x, int y, int sizeX, int sizeY, int formatX);
  void VSB_sget (char *raw, int x, int y, int sizeX, int sizeY, int formatX);

  void VSB_virtual2Real (int *x, int *y);

  #ifdef __cplusplus
  }
  #endif

#endif
